<?php

class GirdGallery_Galleries_Attachment
{

    public function getAttachment($attachmentId, $width = null, $height = null, $crop = false)
    {
        $width  = (int)$width;
        $height = (int)$height;

        $attachment = wp_prepare_attachment_for_js($attachmentId);
        $filePath   = $this->getFilePath($attachment['url']);

        // First try:
        // Trying to find image in wordpress sizes.
        foreach ($attachment['sizes'] as $size) {
            if (($width && $width === $size['width'])
                && ($height && $height === $size['height'])
            ) {
                return $size['url'];
            }
        }

        // Second try
        // Trying to find cropped images.
        $filename = pathinfo($filePath, PATHINFO_FILENAME);
        $filename = $filename . '-' . $width . 'x' . $height . '.' . pathinfo($filePath, PATHINFO_EXTENSION);

        if (is_file($file = dirname($filePath) . '/' . $filename)) {
            return str_replace(ABSPATH, get_bloginfo('wpurl') . '/', $file);
        }

        // Third and last try
        $editor = wp_get_image_editor($filePath);

        if (is_wp_error($editor) || is_wp_error($editor->resize($width, $height, (bool) $crop))) {
            return $attachment['sizes']['full']['url'];
        }

        if (is_wp_error($data = $editor->save())) {
            return $attachment['sizes']['full']['url'];
        }

        $editor = null;
        unset($editor);

        return str_replace(ABSPATH, get_bloginfo('wpurl') . '/', $data['path']);
    }

    protected function getFilePath($url)
    {
        $basepath = untrailingslashit(ABSPATH);

        return  $basepath . str_replace(get_bloginfo('wpurl'), '', $url);
    }

}
