(function($) {

    $(document).ready(function() {
        initCreateDialog();

        if (window.location.hash === '#add') {
            $('#btn-add-new').trigger('click');
        }
    });

    function initCreateDialog() {

        var $container = $('#gg-create-gallery-dialog'),
            $trigger = $('#gg-create-gallery-link, #btn-add-new');

        var request = {
            action: 'gird-gallery',
            title:  'Untitled gallery',
            route:  {
                module: 'galleries',
                action: 'create'
            }
        };

        if (typeof $container === 'undefined' || $container === false)  {
            console.log('The "Create gallery" popup window was not initialized: Container not found.');
            return;
        }

        if (typeof $trigger === 'undefined' || $trigger === false) {
            console.log('The "Create gallery" popup window trigger is undefined');
            return;
        }

        $trigger.on('click', function(e) {
            // e.preventDefault();
            $container.dialog('open');
        });

        $container.dialog({
            modal:    true,
            autoOpen: false,
            buttons:  {
                OK: function() {

                    /* Window layers */
                    var layers = {
                        text:   $('#gg-create-gallery-text'),
                        loader: $('#gg-create-gallery-loader')
                    };

                    layers.text.hide();
                    layers.loader.show();

                    /* Gallery title */
                    var title = $container.find('input').val();

                    if (title) {

                        request = $.extend('', request, {
                            title: title
                        });

                        $.post(wp.ajax.settings.url, request, function(response) {
                            $.jGrowl(response.message);

                            if (!response.error) {
                                document.location.href = document.location.href + '&action=view&gallery_id=' + response.id;
                            }

                        });

                    }

                    layers.text.show();
                    layers.loader.hide();

                    $container.dialog('close');
                },
                Cancel: function() {
                    $container.dialog('close');
                }
            }
        });

    }

})(jQuery);
