(function($) {
    $(document).ready(function() {

        var $frame = $('#preview'),
            $back = $('#back'),
            $messages = $('#messages');

        /*
         Stop script execution if the current page is not preview.
         */
        if ('preview' !== new URI().query(true).action) {
            return;
        }

        /*
         Prevents the direct redirection in the frame and makes
         redirection in the current window.
         */
        $back.on('click', function(e) {
            e.preventDefault();
            window.location.href = $back.attr('href');
        });

        /*
         Replace admin bar in the frame with the back button.
         */
        $frame.load(function() {
            $frame.contents()
                .find('#wpadminbar')
                .html($back);
        });

        /*
         If user leaves the preview page, then we are sending request
         to delete the post with the preview of the gallery.
         */
        $(window).on('beforeunload', function() {

            $.post(wp.ajax.settings.url, {
                action: 'gird-gallery',
                route:   { module: 'galleries', action: 'removePreview' },
                post_id: $frame.data('post')
            });

            return $messages.find('#question').text();
        });

    });
})(jQuery);