<?php

/**
 * Class GirdGallery_Installer_Module
 */
class GirdGallery_Installer_Module extends GirdGallery_Core_Module
{

    /**
     * {@inhertidoc}
     */
    public function onInstall()
    {
        parent::onInstall();

        global $wpdb;

        $tables = include 'schema/create.php';

        foreach ($tables as $table) {
            $wpdb->query(str_replace('{prefix}', $wpdb->prefix, $table));
        }
    }

    /**
     * {@inheritdoc}
     */
    public function onUninstall()
    {
        parent::onUninstall();

        /** @var wpdb $wpdb */
        global $wpdb;

        $queries = include 'schema/drop.php';

        foreach ($queries as $query) {
            $query = str_replace('{prefix}', $wpdb->prefix, $query);
            $wpdb->query($query);
        }
    }
} 