<?php

/**
 * Class GirdGallery_Promo_Controller
 * @package GirdGallery\Promo
 */
class GirdGallery_Promo_Controller extends Rsc_Mvc_Controller
{

    public function indexAction(Rsc_Http_Request $request)
    {
        if ($request->post->has('promo_viewed')) {
            update_option('gird_gallery_promo_shown', 1);
        }

        if (1 === (int) get_option('gird_gallery_promo_shown')) {

            $this->send($request);

            return $this->redirect(
                $this->generateUrl('galleries')
            );
        }

        $config = $this->getEnvironment()->getConfig();
        $config->load('@promo/promo.php');

        return $this->response('@promo/index.twig', array(
            'parameters' => array(
                'url'      => $config->get('promo_plugin_url'),
                'video'    => $config->get('promo_video_url'),
                'features' => $config->get('promo_plugin_features'),
            ),
        ));
    }

    protected function send(Rsc_Http_Request $httpRequest)
    {
        $request = array(
            'url'  => 'http://readyshoppingcart.com/?mod=options&action=saveWelcomePageInquirer&pl=rcs',
            'body' => array(
                'site_url'      => get_bloginfo('wpurl'),
                'site_name'     => get_bloginfo('name'),
                'where_find_us' => $httpRequest->post->get('where_find_us'),
                'desc'          => $httpRequest->post->get($httpRequest->post->get('where_find_us')),
                'plugin_code'   => 'rgg',
            ),
        );

        wp_remote_post($request['url'], array('body' => $request['body']));
    }

} 