<?php

/**
 * Class GirdGallery_Ui_AssetsCollection
 */
class GirdGallery_Ui_AssetsCollection extends Rsc_Common_Collection
{
    /**
     * Adds the asset to the collection
     * @param GirdGallery_Ui_Asset $asset
     * @return GirdGallery_Ui_AssetsCollection
     */
    public function add(GirdGallery_Ui_Asset $asset)
    {
        parent::add($asset->getHandle(), $asset);

        return $this;
    }

    /**
     * Sets the asset
     * @param string $key
     * @param GirdGallery_Ui_Asset $asset
     * @throws InvalidArgumentException
     * @return GirdGallery_Ui_AssetsCollection
     */
    public function set($key, GirdGallery_Ui_Asset $asset)
    {
        if ($key !== $asset->getHandle()) {
            throw new InvalidArgumentException('The handle of the asset my be the same as $key value');
        }

        parent::set($key, $asset);

        return $this;
    }

    /**
     * Returns the asset by handle
     * @param array|string $key
     * @param null $default
     * @return GirdGallery_Ui_Asset
     */
    public function get($key, $default = null)
    {
        return parent::get($key, $default);
    }

    /**
     * Loads the all registered assets.
     */
    public function load()
    {
        foreach ($this->collection as $asset) {
            $asset->load();
        }
    }

} 